// Copyright (C) 2024 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:args/command_runner.dart';
import 'package:wyatt_continuous_deployment/src/core/commands/deploy_app/commands/deploy_android/deploy_android_command.dart';
import 'package:wyatt_continuous_deployment/src/core/commands/deploy_app/commands/deploy_ios/deploy_ios_command.dart';

class DeployAppCommand extends Command<int> {
  DeployAppCommand() {
    addSubcommand(DeployAndroidCommand());
    addSubcommand(DeployIosCommand());
  }

  @override
  String get description => 'Deploy the app';

  @override
  String get name => 'deploy';

  @override
  List<String> get aliases => ['d'];
}
