// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart' hide ButtonStyle;
import 'package:wyatt_component_copy_with_extension/wyatt_component_copy_with_extension.dart';
import 'package:wyatt_ui_components/wyatt_ui_components.dart';
import 'package:wyatt_ui_kit/src/components/buttons/simple_icon_button/simple_icon_button_theme_resolver.dart';
import 'package:wyatt_ui_kit/src/components/buttons/simple_icon_button/simple_icon_screen.dart';

part 'simple_icon_button.g.dart';

@ComponentCopyWithExtension()
class SimpleIconButton extends SimpleIconButtonComponent
    with $SimpleIconButtonCWMixin {
  const SimpleIconButton({
    super.icon,
    super.disabledStyle,
    super.normalStyle,
    super.hoveredStyle,
    super.focusedStyle,
    super.tappedStyle,
    super.onPressed,
    super.disabled,
    super.themeResolver,
    super.key,
  });

  @override
  SimpleIconButtonStyle? get disabledStyle =>
      super.disabledStyle as SimpleIconButtonStyle?;

  @override
  SimpleIconButtonStyle? get normalStyle =>
      super.normalStyle as SimpleIconButtonStyle?;

  @override
  SimpleIconButtonStyle? get hoveredStyle =>
      super.hoveredStyle as SimpleIconButtonStyle?;

  @override
  SimpleIconButtonStyle? get focusedStyle =>
      super.focusedStyle as SimpleIconButtonStyle?;

  @override
  SimpleIconButtonStyle? get tappedStyle =>
      super.tappedStyle as SimpleIconButtonStyle?;

  @override
  SimpleIconButtonThemeResolver? get themeResolver =>
      super.themeResolver as SimpleIconButtonThemeResolver?;

  @override
  Widget build(BuildContext context) => SimpleIconButtonScreen(
        icon: icon,
        disabledStyle: disabledStyle,
        normalStyle: normalStyle,
        hoveredStyle: hoveredStyle,
        focusedStyle: focusedStyle,
        tappedStyle: tappedStyle,
        onPressed: onPressed,
        disabled: disabled,
        themeResolver: themeResolver,
        key: key,
      );
}
